// History.cpp: Implementierung der Klasse CHistory.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "History.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CHistory::CHistory(CComboBox *cbox) :
	m_combobox(cbox)
{

}

CHistory::~CHistory()
{

}

void CHistory::AddSearch(CString searchstring, int searchtype, BOOL filesize,
						 CString minfilesize, CString maxfilesize, BOOL date,
						 CTime datelimit, UINT hits)
{
	HISTORY_ENTRY hist;
	int index;
	
	if ((index = m_combobox->InsertString(-1, searchstring)) < 0)
		return;

	hist.searchstring = searchstring;
	hist.searchtype = searchtype;
	hist.filesize = filesize;
	hist.minfilesize = minfilesize;
	hist.maxfilesize = maxfilesize;
	hist.date = date;
	hist.datelimit = datelimit;
	hist.hits = hits;
	hist.index = index;

	history.Add(hist);
	m_combobox->SetCurSel(index);
}

void CHistory::SelectSearch(CString &searchstring, int &searchtype, BOOL &filesize,
							CString &minfilesize, CString &maxfilesize, BOOL &date,
							CTime &datelimit, UINT &hits)
{
	int index;
	if ((index = m_combobox->GetCurSel()) != CB_ERR)
	{
		HISTORY_ENTRY hist = history[index];
		searchstring = hist.searchstring;
		searchtype = hist.searchtype;
		filesize = hist.filesize;
		minfilesize = hist.minfilesize;
		maxfilesize = hist.maxfilesize;
		date = hist.date;
		datelimit = hist.datelimit;
		hits = hist.hits;
	}
}

void CHistory::SelectLastSearch(CString &searchstring, int &searchtype, BOOL &filesize,
								CString &minfilesize, CString &maxfilesize, BOOL &date,
								CTime &datelimit, UINT &hits)
{
	int index;
	if ((index = m_combobox->GetCount() - 1) > 0)
	{
		HISTORY_ENTRY hist = history[index];
		searchstring = hist.searchstring;
		searchtype = hist.searchtype;
		filesize = hist.filesize;
		minfilesize = hist.minfilesize;
		maxfilesize = hist.maxfilesize;
		date = hist.date;
		datelimit = hist.datelimit;
		hits = hist.hits;
	}
}

CString CHistory::GetSearchID(CString searchstring, int searchtype)
{
	return searchstring;
	
	CString tmp, type;
	
	switch (searchtype)
	{
	case SEARCH_WILDCARD:
		type = "Wildcard";
		break;
	case SEARCH_TEXT:
		type = "Textsuche";
		break;
	case SEARCH_REGEXP:
		type = "Regulrer Ausdruck";
		break;
	}
	tmp.Format("%s [%s]", searchstring, type);
	return tmp;
	
}

void CHistory::SaveHistory(int num)
{
	CFile file;
	HISTORY_ENTRY hist;
	int start, stop;

	stop = history.GetSize();
	if (num == -1)
		start = 0;
	else
	{
		start = history.GetSize() - num;
		if (start < 0)
			start = 0;
	}

	if (file.Open("history.txt", CFile::modeCreate | CFile::modeWrite))
	{
		CArchive arch(&file, CArchive::store);

		for (int i = start; i < stop; i++)
		{
			hist = history[i];
			arch << hist.date << hist.datelimit << hist.filesize;
			arch << hist.hits << hist.index << hist.maxfilesize;
			arch << hist.minfilesize << hist.searchstring << hist.searchtype;
		}

		arch.Close();
		file.Close();
	}
}

void CHistory::LoadHistory()
{
	CFile file;
	int index;

	if (file.Open("history.txt", CFile::modeRead))
	{
		HISTORY_ENTRY hist;
		CArchive arch(&file, CArchive::load);
		bool eof = false;

		history.RemoveAll();

		while (!eof)
		{
			try
			{
				arch >> hist.date >> hist.datelimit >> hist.filesize;
				arch >> hist.hits >> hist.index >> hist.maxfilesize;
				arch >> hist.minfilesize >> hist.searchstring >> hist.searchtype;
				if (index = m_combobox->AddString(GetSearchID(hist.searchstring, hist.searchtype)) >= 0)
				{
					hist.index = index;
					history.Add(hist);
				}
			}
			catch (	CException *e )
			{
				eof = true;
				e->Delete();
			}
		}
		arch.Close();
		file.Close();
	}
}

void CHistory::DeleteHistory()
{
	history.RemoveAll();
	m_combobox->ResetContent();

	try	
	{
		CFile::Remove("history.txt");
	}
	catch (CFileException *e)
	{
		e->Delete();
	}
}
